public class JeuDeLaVie implements Jeu {

    boolean[][] initial = {{false, false, false}, {true, true, true}, {false, false, false}};
    boolean[][] etat = initial;

    @Override
    public void reset() {
        etat = initial;
    }

    private boolean interieur(int i, int j) {
        return i >= 0 && j >= 0 && i < etat.length && j < etat[0].length;
    }

    private int nbVoisin(int i, int j) {
        int res = 0;
        for (int k = -1; k < 2; k++)
            for (int l = -1; l < 2; l++)
                if ((k != 0 || l != 0) && interieur(i + k, j + l))
                    if (etat[i + k][j + l])
                        res++;
        return res;
    }

    @Override
    public void next() {
        boolean[][] suivant = new boolean[etat.length][etat[0].length];
        for (int i=0; i<etat.length;i++)
            for (int j=0; j<etat[0].length;j++) {
                int v= nbVoisin(i,j);
                suivant[i][j] = v==3 || (v==2 && etat[i][j]);
            }
        etat = suivant;
    }

    public String toString() {
        StringBuffer res = new StringBuffer();
        for (boolean[] ligne : etat) {
            for (boolean cellule : ligne) {
                if (cellule)
                    res.append("*");
                else
                    res.append("-");
            }
            res.append("\n");
        }
        return res.toString();
    }
}
