import java.util.ArrayList;
import java.util.Iterator;

public class Matrice {
    static int K = 10;

    static class Cellule {
        int x;
        int y;
        int val;

        Cellule(int x, int y, int val) {
            this.x = x;
            this.y = y;
            this.val = val;
        }
    }

    ArrayList<Cellule> val = new ArrayList<Cellule>();

    public void append(int x,int y, int v) {
        val.add(new Cellule(x,y,v));
    }

    public Matrice decalage(int i, int j) {
        Matrice res = new Matrice();
        for (Cellule cellule : val) {
            Cellule c = new Cellule(cellule.x + i, cellule.y + j, cellule.val);
            res.val.add(c);
        }
        return res;
    }

    public Matrice mult(int a) {
        assert (a!=0);
        Matrice res = new Matrice();
        for (Cellule cellule : val) {
            Cellule c = new Cellule(cellule.x, cellule.y, a * cellule.val);
            res.val.add(c);
        }
        return res;
    }

    public Matrice filtre(int f) {
        Matrice res = new Matrice();
        for (Cellule cellule : val) {
            if (cellule.val == f) {
                Cellule c = new Cellule(cellule.x, cellule.y, 1);
                res.val.add(c);
            }
        }
        return res;
    }

    public Matrice add(Matrice m) {
        Matrice res = new Matrice();
        Iterator<Cellule> iterator1 = val.iterator();
        Iterator<Cellule> iterator2 = m.val.iterator();
        Cellule c1 = (iterator1.hasNext()) ? iterator1.next() : null;
        Cellule c2 = (iterator2.hasNext()) ? iterator2.next() : null;

        while (c1 != null || c2 != null) {
            if (c1 != null && c2 != null && c1.x == c2.x && c1.y == c2.y) {
                if (c1.val+c2.val !=0) {
                    Cellule c = new Cellule(c1.x, c1.y, c1.val + c2.val);
                    res.val.add(c);
                }
                c1 = (iterator1.hasNext()) ? iterator1.next() : null;
                c2 = (iterator2.hasNext()) ? iterator2.next() : null;
            } else if (c1 != null &&
                    (c2 == null || (c1.x < c2.x) ||
                            (c1.x == c2.x && c1.y < c2.y))) {
                Cellule c = new Cellule(c1.x, c1.y, c1.val);
                res.val.add(c);
                c1 = (iterator1.hasNext()) ? iterator1.next() : null;
            } else {
                Cellule c = new Cellule(c2.x, c2.y, c2.val);
                res.val.add(c);
                c2 = (iterator2.hasNext()) ? iterator2.next() : null;
            }
        }
        return res;
    }

    public String toString() {
        StringBuffer res = new StringBuffer();
        Iterator<Cellule> iterator = val.iterator();
        Cellule c = (iterator.hasNext()) ? iterator.next() : null;

        for (int i = -K+1;i<K;i++) {
            for (int j = -K + 1; j < K; j++) {
                if (c!=null && c.x==i && c.y==j) {
                    res.append("*");
                    c = (iterator.hasNext()) ? iterator.next() : null;
                }
                else
                    res.append("-");
            }
            res.append("\n");
        }
        return res.toString();
    }
}
